#ifndef APPCOMMANDS_H
#define APPCOMMANDS_H

#include "ggs.h"
#include "parameters.h"
#include "appParameters.h"
#include "serialNumber.h"
#include "settings.h"

#define CMD_CORTAR                          0x07
#define RESP_CORTAR                         0x08
#define CMD_RELIGAR                         0x09
#define RESP_RELIGAR                        0x0a
#define CMD_ESTADO_FORNECIMENTO             0x0b
#define RESP_ESTADO_FORNECIMENTO            0x0c
#define CMD_LER_VERSAO                      0x13
#define RESP_LER_VERSAO                     0x14
#define CMD_RESET                           0x15
#define RESP_RESET                          0x16
#define CMD_LER_NUM_SERIE                   0x17
#define RESP_LER_NUM_SERIE                  0x18
#define CMD_GRAVAR_NUM_SERIE                0x19
#define RESP_GRAVAR_NUM_SERIE               0x1a
#define CMD_LER_PARAMETROS                  0x1b
#define RESP_LER_PARAMETROS                 0x1c
#define CMD_CONFIGURAR_PARAMETROS           0x1d
#define RESP_CONFIGURAR_PARAMETROS          0x1e
#define CMD_LER_RELOGIO                     0x1f
#define RESP_LER_RELOGIO                    0x20
#define CMD_TENSAO_INSTANTANEA              0x21
#define RESP_TENSAO_INSTANTANEA             0x22
#define CMD_CORRENTE_INSTANTANEA            0x23
#define RESP_CORRENTE_INSTANTANEA           0x24
#define CMD_MM_TENSAO                       0x25
#define RESP_MM_TENSAO                      0x26
#define CMD_MM_CORRENTE                     0x27
#define RESP_MM_CORRENTE                    0x28
#define CMD_DETECTA_CARGA                   0x29
#define RESP_DETECTA_CARGA                  0x2a


extern CommandExecutor exec;
extern Parameters param;
extern SerialNumber sn;
extern ParametersBlock APP_PARAMETERS;
extern void softReset();

void enviaRespostaGGS(char * dados, int tamanho);
void executaComando(unsigned char tamanho, unsigned char sequencia, unsigned char tipo, char * dados);

void cmdLerVersao();
void cmdLerNumeroSerie();
void cmdGravarNumeroSerie(char * dados, unsigned char tamanhoDados);
void cmdReset();
void cmdLerParametros();
void cmdConfigurarParametros(char * dados, unsigned char tamanhoDados);
void cmdLerRelogio();

void cmdCortar();
void cmdReligar();
void cmdEstadoFornecimento();
void cmdDetectaCarga();

void cmdTensaoInstantanea(unsigned char lineOrLoad);
void cmdMMTensao(unsigned char lineOrLoad);

void atualizaEstadoRele(unsigned char estado);
unsigned char lerEstadoRele();

#endif
