#include "appCommands.h"
#include "sensor.h"

#define DETECTA_CARGA_SUCESSO               0
#define DETECTA_CARGA_FALHA                 1
#define DETECTA_CARGA_FALHA_GRAVAR_PARAM    2

extern DigitalOut set_relay;
extern DigitalOut reset_relay;

void corta(){
    reset_relay = RELE_ON;
    wait_ms(APP_PARAMETERS.CORTAR_LARGURA_PULSO_MS);
    reset_relay = RELE_OFF;
    atualizaEstadoRele(ESTADO_RELE_ABERTO);
}

void religa(){
    set_relay = RELE_ON;
    wait_ms(APP_PARAMETERS.RELIGAR_LARGURA_PULSO_MS);
    set_relay = RELE_OFF;
    atualizaEstadoRele(ESTADO_RELE_FECHADO);
}

void cmdDetectaCarga(){
    bool ch0Status = getEstadoSensor(0);
    bool ch1Status = getEstadoSensor(1);
    
    if(ch0Status && ch1Status){ // Ambos alimentados: Linha e Carga. Tera que cortar para determinar qual e a carga
        corta();
        wait_ms(APP_PARAMETERS.DELAY_SENSOR_MS);
        if(getEstadoSensor(0) == SENSOR_SEM_FORNECIMENTO){
            APP_PARAMETERS.LOAD_CHANNEL = 0;
        } else if(getEstadoSensor(1) == SENSOR_SEM_FORNECIMENTO){
            APP_PARAMETERS.LOAD_CHANNEL = 1;
        } else{
            religa();
            exec.enviaResposta(RESP_DETECTA_CARGA, DETECTA_CARGA_FALHA);
            return;
        }
        religa();
    } else if(!ch0Status && ch1Status){    // Canal 0 nao esta alimentado e Canal 1 esta: entao a carga certamente e o canal 0
        APP_PARAMETERS.LOAD_CHANNEL = 0;
    } else if(ch0Status && !ch1Status){    // Canal 1 nao esta alimentado e Canal 0 esta: entao a carga certamente e o canal 1
        APP_PARAMETERS.LOAD_CHANNEL = 1;
    } else{ // Erro ao verificar alimentacao: os 2 canais reportaram que estao sem alimentacao, o que nao seria possivel
        exec.enviaResposta(RESP_DETECTA_CARGA, DETECTA_CARGA_FALHA);
        return;
    }
    if(!param.saveParameters()){
        printf("[GGS] Erro gravando parametro de lado da carga\r\n");
        exec.enviaResposta(RESP_DETECTA_CARGA, DETECTA_CARGA_FALHA_GRAVAR_PARAM);
        return;
    }
    exec.enviaResposta(RESP_DETECTA_CARGA, DETECTA_CARGA_SUCESSO);
}
