#include "memoriaMassa.h"

void MemoriaMassa::iniciaLeituras(int periodoSec, int size){
    mmPeriodoSec = periodoSec;
    queue[0].init(size, 3);
    queue[1].init(size, 4);
    leituraPeriodica.attach(this, &MemoriaMassa::disparaLeitura, mmPeriodoSec);
}

void MemoriaMassa::disparaLeitura(){
    lerAgora = true;
}

void MemoriaMassa::executaLeitura(){
    if(!lerAgora){
        return;
    }
    
    LeituraMM leitura;
    leitura.value.floatValue = getTensaoInstantanea(0);
    leitura.time = time(NULL);
    queue[0].add((char*)&leitura);
    
    leitura.value.floatValue = getTensaoInstantanea(1);
    queue[1].add((char*)&leitura);

    lerAgora = false;
}

char* MemoriaMassa::getMM(int channel){
    if(channel < 0 || channel > 1){
        printf("[MM] Invalid channel %d\r\n", channel);
        return NULL;
    }
    return queue[channel].getAll();
}
