#ifndef MM_H
#define MM_H

#include "mbed.h"
#include "queue.h"
#include "sensor.h"

typedef struct{
    unsigned int time;
    union{
        float floatValue;
        unsigned char bytes[4];
    } value;
} LeituraMM;

class MemoriaMassa {

    Ticker leituraPeriodica;
    int mmPeriodoSec;
    bool lerAgora;
    
    PersistentCircularQueue queue[2];
    
  public:
    void iniciaLeituras(int periodoSec, int size);
    void disparaLeitura();
    void executaLeitura();
    char* getMM(int channel);

};

#endif
